//+------------------------------------------------------------------+
//|                                                     MACD_CCI.mq4 |
//+------------------------------------------------------------------+

#property  indicator_separate_window
#property  indicator_buffers 3
#property  indicator_color1  RoyalBlue
#property  indicator_color2  Red
#property  indicator_color3  Orange
#property  indicator_minimum 0
#property  indicator_maximum 77

//
//
//
//
//

extern string TimeFrame  = "current time frame";
extern int    macdMAfast = 144;
extern int    macdMAslow = 233;
extern int    macdSigMA  =  21;
extern int    macdPrice  =   0;
extern int    macdLnMode =   0;
extern int    CCIperiod  =  50;
extern int    CCIprice   =   5;
extern double BarLevl    =   5;

//
//
//
//
//

extern string MA_Method_Price = "SMA0 EMA1 SMMA2 LWMA3||0O,1C 2H3L,4Md 5Tp 6WghC: Md(HL/2)4,Tp(HLC/3)5,Wgh(HLCC/4)6||macdLnMode:0main 1sig";
extern int    alertSwitch     = 1; 

//
//
//
//
//

double buffer1[];
double buffer2[];
double buffer3[];

int      timeFrame;
datetime lastABar;
bool     returningBars=false;
string   IndicatorFileName;
string   timeFrameDescription="current time frame";

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   SetIndexBuffer(0,buffer1); SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,167); SetIndexEmptyValue(0,EMPTY_VALUE); 
   SetIndexBuffer(1,buffer2); SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,167); SetIndexEmptyValue(1,EMPTY_VALUE);
   if (TimeFrame=="gettingBars")
   {
      returningBars = true;
      return(0);
   }
   SetIndexBuffer(2,buffer3); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,167); SetIndexEmptyValue(2,EMPTY_VALUE); 
      
   //
   //
   //
   //
   //
      
   timeFrame            = stringToTimeFrame(TimeFrame);
   timeFrameDescription = TimeFrameToString(timeFrame);
   IndicatorFileName = WindowExpertName();

      string name1= " macd ("+macdMAfast+","+macdMAslow+","+macdSigMA+")";
      string name2= " cci (" +CCIperiod+")";
   IndicatorShortName("MACD-CCI "+TimeFrameToString(timeFrame)+name1+name2);  
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int i,limit;

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
      limit = MathMin(Bars - counted_bars,Bars-1);

      if (returningBars) { buffer1[0] = limit;  for (i=limit;i>=0; i--) buffer1[i] = Close[i]; return(0); }
      if (timeFrame > Period()) limit = MathMax(limit,MathMin(Bars,iCustom(NULL,timeFrame,IndicatorFileName,"returnBars",0,0)*timeFrame/Period()));

   //
   //
   //
   //
   //
      
   for (i=limit; i>= 0; i--)
   {
      int y =iBarShift(NULL,timeFrame,Time[i]);

         double  macd0 = iMACD(NULL,timeFrame,macdMAfast,macdMAslow,macdSigMA,macdPrice,macdLnMode,y);
         double  macd1 = iMACD(NULL,timeFrame,macdMAfast,macdMAslow,macdSigMA,macdPrice,macdLnMode,y+1);
         double  cci   = iCCI (NULL,timeFrame,CCIperiod,CCIprice,y);
                
         buffer1[i]=EMPTY_VALUE;
         buffer2[i]=EMPTY_VALUE;
         buffer3[i]=EMPTY_VALUE;
      
         if (cci > 0 && macd0 > macd1) buffer1[i] = BarLevl;
         else 
            if (cci < 0 && macd0 < macd1) buffer2[i] = BarLevl;  
            else                          buffer3[i] = BarLevl;
   }
   
   //
   //
   //
   //
   //
   
   if (alertSwitch == 1 && Time[0] != lastABar)
   {
      if (buffer1[0] != EMPTY_VALUE && buffer1[1] == EMPTY_VALUE)
      {
         Alert(Symbol(), " Indicator MACD_CCI "+timeFrameDescription+" change color to blue");
         lastABar = Time[0];
      }
      if (buffer2[0] != EMPTY_VALUE && buffer2[1] == EMPTY_VALUE)
      {
         Alert(Symbol(), " Indicator MACD_CCI "+timeFrameDescription+" change color to red");
         lastABar = Time[0];
      }
   }
            
   return(0);
}

//+------------------------------------------------------------------+
//|
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   int tf=0;
       tfs = StringTrimLeft(StringTrimRight(StringUpperCase(tfs)));
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
         if (tf<Period()) tf=Period();
  return(tf);
}
string TimeFrameToString(int tf)
{
   string tfs="";
   
   if (tf!=Period())
      switch(tf) {
         case PERIOD_M1:  tfs="M1"  ; break;
         case PERIOD_M5:  tfs="M5"  ; break;
         case PERIOD_M15: tfs="M15" ; break;
         case PERIOD_M30: tfs="M30" ; break;
         case PERIOD_H1:  tfs="H1"  ; break;
         case PERIOD_H4:  tfs="H4"  ; break;
         case PERIOD_D1:  tfs="D1"  ; break;
         case PERIOD_W1:  tfs="W1"  ; break;
         case PERIOD_MN1: tfs="MN1";
      }
   return(tfs);
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;
   int      lenght = StringLen(str) - 1;
   int      char;
   
   while(lenght >= 0)
      {
         char = StringGetChar(s, lenght);
         
         //
         //
         //
         //
         //
         
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                  s = StringSetChar(s, lenght, char - 32);
         else 
              if(char > -33 && char < 0)
                  s = StringSetChar(s, lenght, char + 224);
         lenght--;
   }
   return(s);
}